
BAD_BLOCKS=0
RT_MESS=''

# integrity check
if [ -z "${RT_THRESH}" ] || [ "${RT_THRESH}" != "${RT_THRESH//[^0-9]/}" ] ; then
   RT_THRESH=20
fi

# detect drives
SD_DRIVES=$( df | grep ^/dev/sd | cut -d' ' -f1 | sed -e 's/.$//' \
               | sort | uniq | xargs )
# echo "SATA drives: ${SD_DRIVES}"

NVME_DRIVES=$( df | grep ^/dev/nvme | cut -d' ' -f1 | sed -e 's/..$//' \
               | sort | uniq | xargs )
# echo "NVME drives: ${NVME_DRIVES}"

# nvme drives
for M_DRIVE in ${NVME_DRIVES} ; do
   # echo "Checking NVME drive ${M_DRIVE}"
   DIE_BLOCKS=$( smartctl -a ${M_DRIVE} | \
                 grep 'Media and Data Integrity Errors' \
                 | awk '{print $NF}' )
   DIE_BLOCKS=${DIE_BLOCKS//[^0-9]/}
   if [ -n "${DIE_BLOCKS}" ] && [ "${DIE_BLOCKS}" -gt '0' ] ; then
      BAD_BLOCKS=$(( ${BAD_BLOCKS} + ${DIE_BLOCKS} ))
      if [ "${DIE_BLOCKS}" -gt "${RT_THRESH}" ] ; then
         RT_MESS="${RT_MESS} Drive ${M_DRIVE} has ${DIE_BLOCKS} data integrity errors;"
      fi
   fi
done

# /dev/sd* drives
for M_DRIVE in ${SD_DRIVES} ; do
   # try sata format
   # echo "Checking SATA drive ${M_DRIVE}"
   RSC_BLOCKS=$( smartctl -a ${M_DRIVE} | \
                 grep 'Reallocated_Sector_Ct' \
                 | awk '{print $NF}' )
   RSC_BLOCKS=${RSC_BLOCKS//[^0-9]/}

   if [ -z "${RSC_BLOCKS}" ] ; then
      # try storcli format
      STOR_CLI=$( which storcli64 storcli | head -n1 )
      if [ -z "${STOR_CLI}" ] ; then
         # try a fix if  storcli64 is in Windowshead path
         STOR_CLI_TEST=$( locate /storcli64 | grep storcli64$  | head -n1 )
         if [ -n "${STOR_CLI_TEST}" ] ; then
            ln -sf "${STOR_CLI_TEST}" /usr/sbin/storcli64
            STOR_CLI='/usr/sbin/storcli64'
         fi    
      fi
            
      if [ -n "${STOR_CLI}" ] ; then
         RSC_BLOCKS=$( ${STOR_CLI}  /c0 /eall /sall show all | \
                      grep 'Media Error Count' \
                      | awk '{sum += $NF} END {print sum}' )
         RSC_BLOCKS=${RSC_BLOCKS//[^0-9]/}         
      fi
   fi

   # add up bad blocks
   if [ -n "${RSC_BLOCKS}" ] && [ "${RSC_BLOCKS}" -gt '0' ] ; then
      BAD_BLOCKS=$(( ${BAD_BLOCKS} + ${RSC_BLOCKS} ))
      if [ "${RSC_BLOCKS}" -gt "${RT_THRESH}" ] ; then
         RT_MESS="${RT_MESS} Drive ${M_DRIVE} has ${RSC_BLOCKS} reallocated sectors;"
      fi
   fi
done

PI_PARAM="${PI_PARAM}&BadBlocks=${BAD_BLOCKS}"

# send message if situation is serious
if [ -n "${RT_MESS}" ] && [ -e "/usr/bin/mail" ] ; then
   RT_SUBJ="Bad blocks alarm on ${PI_HOSTNAME}"
   cat <<< ${RT_MESS} | tr ';' '\n' \
         |  /usr/bin/mail -s "${RT_SUBJ}" ${RT_ADDRESS}
fi

