
# backup details
BKPTEST=''

# check crontab for active backup tasks
if [ -r "/etc/cron.d/etob-bkp" ] ; then
   BKPTEST=$( cat /etc/cron.d/etob-bkp | sed -e "s/#.*$//" | \
              grep -a "etob-bkp" )
fi

# collect the info
if [ -n "${BKPTEST}" ] ; then
   PI_PARAM="${PI_PARAM}&etobBKP=enabled"
   
   # local or collect
   if [ -f "/var/tob/etc/etob-server.conf" ] ; then
      . /var/tob/etc/etob-server.conf
      if [ -z "${ETOBCOLLECTSERVER}" ] ; then
         PI_PARAM="${PI_PARAM}&etobBKPstore=localhost"
      else
         PI_BKP_COLLECT=$( cat <<< ${ETOBCOLLECTSERVER} | \
               sed -e "s/[^${ALLOWED_CHARS}]/_/g" | \
               tr '[:upper:]' '[:lower:]' )
         if [ -n "${PI_BKP_COLLECT}" ] ; then
            PI_PARAM="${PI_PARAM}&etobBKPstore=${PI_BKP_COLLECT}"
         fi
      fi
   fi
   
   # last performed
   if [ -d "/var/tob/lists" ] ; then
      if [ -z "$( find /var/tob/lists -type f )" ] ; then
         PI_PARAM="${PI_PARAM}&etobLast=unknown"
      else
         PI_BKP_TIME=$( find /var/tob/lists -type f -printf '%T@\n' | sort -n | tail -1 ) 
         if [ -n "${PI_BKP_TIME}" ]; then
            PI_BKP_TIME=$( date --iso-8601 -d @${PI_BKP_TIME} )
            PI_PARAM="${PI_PARAM}&etobLast=${PI_BKP_TIME}"
         else
            PI_PARAM="${PI_PARAM}&etobLast=unknown"
         fi
      fi
   else
      PI_PARAM="${PI_PARAM}&etobLast=noListDir"
   fi
else
   PI_PARAM="${PI_PARAM}&etobBKP=disabled"
fi

# clean lingering locks
if [ "$( echo /var/tob/backups/.lock_* )" != \
      "/var/tob/backups/.lock_*" ] ; then
   /bin/rm -f /var/tob/backups/.lock_*
fi